/*=====================================================================*/
/*                                                                     */
/*       FILE NAME:        hardcore.c                                  */
/*                                                                     */
/*       PROGRAM NAME:     hardcore    (prog. 1.4)                     */
/*                                                                     */
/*                                                                     */
/*   Version 1.00                                                      */
/*                                                                     */
/*   (c) Satoru Ozawa and Dieter W. Heermann                           */
/*   Hitachi, Heidelberg July 1994                                     */
/*                                                                     */
/*=====================================================================*/

/***********************************************************************/
/* a hard-core particle                                                */
/***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "sgl.h"                    /* include files for graphics */

#define  tmax     100.              /* maximum of time  */
#define  dt       0.1               /* time interval    */
#define  vx       0.2               /* initial velocity */
#define  vy       0.1
#define  x0       0.5               /* initial position */
#define  y0       0.5
#define  r        0.02              /* radius of disc   */

void  main(int argc, char *argv[])
{
  int     i;
  float   x, y, t, dx, dy;

  sgl_winsize(500,500);             /* display-size in pixels */
  sgl_init();                       /* initialize graphics    */
   
  x = x0;                           /* initial conditions     */
  y = y0;

  dx = vx*dt;
  dy = vy*dt;

  for(t=0; t<=tmax; t+=dt){
    x += dx;
    y += dy;
     
    if(x<=0. || x>=1.)              /* reflection at boundary */
      dx = -dx;
    if(y<=0. || y>=1.)
      dy = -dy;
      
    sgl_disc(x, y, r);              /* display motion         */
    sgl_display();
  }
  i = getchar();                    /* hold final pricture    */
}

