/* Example program "example_1.c", (C) Christian Muenkel 1994 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"sgl.h"

#define	N	20		/* number of particles			*/
#define	TIMES	10		/* number of integration time steps	*/
#define	DX	0.02		/* max. displacement of partices	*/
#define	DY	0.02		/*	i.e. velocities			*/

#ifdef  __STDC__
void    main(int argc, char *argv[])
#else 
void    main(argc,argv)  
        int     argc; 
        char    *argv[]; 
#endif
{
 int	i,j;
 int	c1,c2;
 double	drand48();
 float	x[N],y[N],dx[N],dy[N],r,d;

 sgl_winsize(400,400);		/* optionial! default ist 256x256	*/
 sgl_init();			/* initialize graphics, single window	*/
 
 c1 = sgl_colordef("VioletRed1");	/* color definition of color 1	*/
 c2 = sgl_colordef("SeaGreen2");	/*   color 2			*/
 sgl_color_background(sgl_colordef("RoyalBlue3")); /* and background	*/

 srand48(4711);			/* initialize random number generator	*/
 for (i = N-1; i >= 0; i--)
  { x[i] = (float) drand48();	/* initialize particle positions	*/
    y[i] = (float) drand48();
    dx[i] = (float) (2.0*drand48()-1.0) * DX;	/* and displacements	*/
    dy[i] = (float) (2.0*drand48()-1.0) * DY;
  }

 r = 0.03;			/* radius of circles, discs		*/
 d = 2.0 * r;			/* width and height of rectangles	*/


 for (j = TIMES; j > 0; j--)	/* integrate motion of particles	*/
  { for (i = N-1; i >= 0; i--)
     { x[i] += dx[i];		/* move particles			*/
       y[i] += dy[i];
       if (x[i] <= 0.0 || x[i] >= 1.0)	/* reflection on boundary	*/
		dx[i] = -dx[i];
       if (y[i] <= 0.0 || y[i] >= 1.0)
		dy[i] = -dy[i];
       if (i%2 == 0)			/* even/odd particles have	*/
	{ sgl_color(c1);		/*	different colors	*/
          sgl_disc(x[i],y[i],r);	/*	and shapes		*/
          sgl_color(SGL_BLACK);		/* but each one has a black	*/
          sgl_circle(x[i],y[i],r);	/* 	boundary		*/
        }
       else
	{ sgl_color(c2);
          sgl_rectarea(x[i],y[i],d,d);
          sgl_color(SGL_BLACK);
          sgl_rectangle(x[i],y[i],d,d);
        }
     }
    sgl_display();		/* don't forget to display the drawing	*/
 i = getchar();
  }
}
